package bluetoothIM.Controller;

import java.io.IOException;
import java.util.ArrayList;

import bluetoothIM.Protocol.Connections.Connecting;
import bluetoothIM.Protocol.Connections.Listening;
import bluetoothIM.Protocol.Connections.Scanning;
import bluetoothIM.Protocol.Conversations.Room;
import bluetoothIM.Protocol.Routing.RoutingTable;
import bluetoothIM.View.MainActivity;
import bluetoothIM.View.R;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class ViewController extends Activity implements OnItemClickListener,
		OnItemSelectedListener { // Tda propojujc protokol a uivatelsk rozhan

	public static Handler handler;
	private Button Send;
	private Spinner Members;
	private ListView InRange;
	private TextView Input;
	private EditText Output;
	private Button Scan;
	private TextView Conversation;
	private MainActivity Main;
	private Thread threadS;
	private ScrollView Scview;
	private MediaPlayer mediaPlayer;
	
	// Get/Set metody
	public Button getSend() {
		return Send;
	}

	public void setSend(Button send) {
		Send = send;
	}

	public Spinner getMembers() {
		return Members;
	}

	public void setMembers(Spinner members) {
		Members = members;
	}

	public ListView getInRange() {
		return InRange;
	}

	public void setInRange(ListView inRange) {
		InRange = inRange;
	}

	public TextView getInput() {
		return Input;
	}

	public void setInput(TextView input) {
		Input = input;
	}

	public EditText getOutput() {
		return Output;
	}

	public void setOutput(EditText output) {
		Output = output;
	}

	public Button getScan() {
		return Scan;
	}

	public void setScan(Button scan) {
		Scan = scan;
	}

	public TextView getConversation() {
		return Conversation;
	}

	public void setConversation(TextView conversation) {
		Conversation = conversation;
	}

	public MainActivity getMain() {
		return Main;
	}

	public void setMain(MainActivity main) {
		Main = main;
	}

	public Thread getThreadS() {
		return threadS;
	}

	public void setThreadS(Thread threadS) {
		this.threadS = threadS;
	}

	public ScrollView getScview() {
		return Scview;
	}

	public void setScview(ScrollView scview) {
		Scview = scview;
	}

	@SuppressLint("HandlerLeak")
	public ViewController(ScrollView scview, TextView conversation, // Konstruktor
			Button send, Spinner spinner, ListView inRange, TextView input,
			EditText output, Button scan, MainActivity main) {
		
		
		Conversation = conversation;
		Conversation.setText("Room is empty");
		Send = send;
		Scview = scview;
		Input = input;
		Output = output;
		Scan = scan;
		Main = main;
		Members = spinner;
		Members.setOnItemSelectedListener(this);
		InRange = inRange;
		InRange.setOnItemClickListener(this);
		mediaPlayer = MediaPlayer.create(Main,
				R.drawable.beep);
		Scan.setOnClickListener(new OnClickListener() { // Nastaven metod pi stisku tlatka

			@Override
			public void onClick(View v) {
				scan();

			}

		});
		Send.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				send();

			}
		});
		Input.setMovementMethod(ScrollingMovementMethod.getInstance());
	
		init();
		handler = new Handler() { // Tvorba instance handleru, kter zpracovv zprvy pedn protokolem
			@SuppressWarnings("unchecked")
			@Override
			public void handleMessage(Message msg) {
			
				try
				{
				switch (msg.what) {
				case -4:
					Toast.makeText(Main, (String)msg.obj, Toast.LENGTH_LONG)
					.show();
					break;
				case -3:
					Toast.makeText(Main, (String)msg.obj, Toast.LENGTH_LONG)
					.show();
					break;
				case -2:
					Toast.makeText(Main, (String)msg.obj, Toast.LENGTH_LONG)
					.show();
					break;
				case -1:
					Toast.makeText(Main, (String)msg.obj, Toast.LENGTH_LONG)
					.show();
					break;
				case 0:
					Scan.setText("SCAN");
					break;
				case 1:
					InRange.setAdapter(new ArrayAdapter<String>(Main,
							android.R.layout.simple_list_item_1,
							(ArrayList<String>) msg.obj));
					break;
				case 2:
					ArrayList<String> membersToSet = new ArrayList<String>();
					for(String s : (ArrayList<String>)msg.obj)
					{
						membersToSet.add(s);
						
					}
					Members.setAdapter(new ArrayAdapter<String>(Main,
							android.R.layout.simple_list_item_1,
							membersToSet));
					if (Members.getCount() != 0)
					{
						Members.setSelection(Members.getCount() - 1);
						Conversation.setText(Members.getSelectedItem().toString());
						
						if (Members.getSelectedItem().equals("Everyone")) {
							Input.setText((CharSequence) Room.getConversations()
									.get("Everyone").getInStringConversation());
						
						} 
						else
							{
							Input.setText((CharSequence) Room
									.getConversations()
									.get(RoutingTable.getNameAddressPairs().get(
											(CharSequence) Members
													.getSelectedItem()))
									.getInStringConversation());
							}
						Scview.fullScroll(ScrollView.FOCUS_DOWN);
						}
					else{
						Conversation.setText("");
						Input.setText("");
						if(Members.getCount() == 0){
							Toast.makeText(Main, "ROOM IS EMPTY", Toast.LENGTH_LONG)
							.show();
							Conversation.setText("ROOM IS EMPTY");
						}
						}
						break;
				default:
					Input.setText((CharSequence) msg.obj);
					Conversation.setText(Members.getItemAtPosition(
							(msg.what) - 3).toString());
					Scview.fullScroll(ScrollView.FOCUS_DOWN);
					
					mediaPlayer.start();
					break;
				}
				}
				catch(IndexOutOfBoundsException e)
				{
					Input.setText("");
					Conversation.setText("");
					Members.setSelected(false);
					
			
				}
				}
			
			
		};
		Room.setHandler(handler);
		  
		
	}
	public void close()
	{
		for(String s : RoutingTable.getAddressDirectlyConnectedPairs().keySet())
		{
		try {
			RoutingTable.getAddressDirectlyConnectedPairs().get(s).close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		}
	
	}
	public void init() { // Vlkno zanajc naslouchn
		Thread threadL = new Thread() {
			public void run() {
				Listening.setupListener(handler);
			}
		};
		threadL.start();
	}


	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) { // Metoda zpracovvajc vsledek dialogu o zapnut Bluetooth
		super.onActivityResult(requestCode, resultCode, data);
		if (resultCode == RESULT_CANCELED) {
			Toast.makeText(getApplicationContext(),
					"Bluetooth is necessary!",
					Toast.LENGTH_SHORT).show();
			
			finish();
		}
	
	}

	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position, // Metoda zpracovvajc pokyn k pipojen
			long id) {
		Connecting connecting;
		connecting = new Connecting(Scanning.getFoundDevices().get(position));
		connecting.connectToDevice(handler);
	}

	public void Send(String string) { // Odesln zprvy
		Room.sendMessageTo(Members.getSelectedItem().toString(), string);
	}

	@Override
	public void onItemSelected(AdapterView<?> parent, View view, int position, // Metoda slouc k pepnn konverzace
			long id) {

		
		
			Conversation.setText((CharSequence) Members.getSelectedItem());
			if (Members.getSelectedItem().equals("Everyone"))
				Input.setText((CharSequence) Room.getConversations()
						.get("Everyone").getInStringConversation());
			else
				Input.setText((CharSequence) Room
						.getConversations()
						.get(RoutingTable.getNameAddressPairs().get(
								(CharSequence) Members.getSelectedItem()))
						.getInStringConversation());
	
	
	}

	@Override
	public void onNothingSelected(AdapterView<?> parent)
	{
	}

	public void send() { // Obnoven konverzace pi posln zprvy
		if(Members.getCount() > 0 && Members.getSelectedItem() != null)
		{
		Send(Output.getText().toString());
		Output.setText("");
		if (Members.getSelectedItem().equals("Everyone"))
			Input.setText((CharSequence) Room.getConversations()
					.get("Everyone").getInStringConversation());
		else
			Input.setText((CharSequence) Room
					.getConversations()
					.get(RoutingTable.getNameAddressPairs().get(
							(CharSequence) Members.getSelectedItem()))
					.getInStringConversation());
		}
	}

	private void scan() { // Zahjen skenovn
		if (Scan.getText().equals("SCAN")) {

			threadS = new Thread() {
				public void run() {
					Looper.prepare();
					Scanning.startDiscovery();
					Scanning.startReceiving(Main, handler);
				}
			};
			threadS.start();
			Scan.setText("SCANNING...");
		}

	}

}
