package bluetoothIM.Protocol.Connections;

import java.io.IOException;
import java.util.UUID;

import bluetoothIM.Controller.ViewController;
import bluetoothIM.Protocol.Conversations.Room;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.os.Handler;

public class Connecting { // Tda k vytvoen spojen
	private final BluetoothSocket bluetoothSocket;
	private final UUID MY_UUID = UUID
			.fromString("00001101-0000-1000-8000-00805F9B34FB");
	private final BluetoothDevice device;

	public Connecting(BluetoothDevice Device) { // Konstuktor
		device = Device;
		
		BluetoothSocket tmp = null;

		try {

			tmp = device.createRfcommSocketToServiceRecord(MY_UUID);
		} catch (IOException e) {
		}
		bluetoothSocket = tmp;
	}

	public void connectToDevice(Handler handler) { // Pipojen k zazen

		
		try {

			bluetoothSocket.connect();
			Room.onConnect(bluetoothSocket);
			

		} catch (IOException connectException) {
			
			ViewController.handler.obtainMessage(-3, "Connection was not succesfull").sendToTarget();
			try {
				bluetoothSocket.close();
			} catch (IOException closeException) {
				cancel();
			}

		}

	}

	
	public BluetoothSocket getBluetoothSocket() {

		return bluetoothSocket;
	}

	// Ru spojen
	public void cancel() { // Ruen spojen
		try {
			bluetoothSocket.close();
		} catch (IOException e) {
		}
	}

}
