package bluetoothIM.Protocol.Connections;


import java.io.IOException;

import bluetoothIM.Protocol.Routing.RoutingHandler;
import bluetoothIM.View.MainActivity;
import android.bluetooth.BluetoothSocket;
import android.nfc.FormatException;

public class InputOutput { // Tda pro ten a zpis ze streamu


	public static MainActivity main;
	
	public static void write(BluetoothSocket socket, String packet) { // Odesln paket
		
		try {
			
			byte[] bytes = packet.getBytes("UTF-16LE");
			socket.getOutputStream().write(bytes);
		} catch (Exception e) {
			
			
			RoutingHandler.badPacketReceived(socket.getRemoteDevice().getAddress());
			cancel(socket);
			return;
		}
		
	}

	public static void cancel(BluetoothSocket socket) { // Ruen spojen
		try {
			socket.close();
		} catch (IOException e) {
		}
	}

	public static void getStream(final BluetoothSocket socket) { // Pjem paket
		Thread thread = new Thread() {

			public void run() {
				String address = socket.getRemoteDevice().getAddress();
				while (true) {
					try {
						byte[] buffer = new byte[40150];
						socket.getInputStream().read(buffer);
						String s = new String(buffer, "UTF-16LE");
						if(s.charAt(0)=='\0')
							throw new FormatException();
						RoutingHandler.routePacket(s, socket);
					
					} 
					
					catch (Exception e) {
						
						RoutingHandler.badPacketReceived(address);
						cancel(socket);
						return;
					}
				}
			}

		};
		
		thread.start();

	}
	

	
}
