package bluetoothIM.Protocol.Connections;

import java.util.ArrayList;

import bluetoothIM.View.MainActivity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Handler;

public class Scanning { // Tda pro vyhledvan zazen v okol
	private static BluetoothAdapter bluetoothAdapter;
	private static BroadcastReceiver receiver;
	private static IntentFilter filter;
	private static ArrayList<BluetoothDevice> foundDevices = new ArrayList<BluetoothDevice>();
	private static ArrayList<String> listOfDevices = new ArrayList<String>();

	static { // Konstruktor
		bluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		foundDevices = new ArrayList<BluetoothDevice>();
		listOfDevices = new ArrayList<String>();

	}
	// Get/Set metody
	public static ArrayList<BluetoothDevice> getFoundDevices() {
		return foundDevices;
	}

	public static void setFoundDevices(ArrayList<BluetoothDevice> foundDevices) {
		Scanning.foundDevices = foundDevices;
	}

	public static ArrayList<String> getListOfDevices() {
		return listOfDevices;
	}

	public static void setListOfDevices(ArrayList<String> ListOfDevices) {
		listOfDevices = ListOfDevices;
	}

	public static void setBluetoothAdapter(BluetoothAdapter BluetoothAdapter) {
		bluetoothAdapter = BluetoothAdapter;
	}
	public static BluetoothAdapter getBluetoothAdapter() {
		return bluetoothAdapter;
	}

	
	
	public static void startDiscovery() { // Start vyhledvn
		if(bluetoothAdapter.isDiscovering())
			bluetoothAdapter.cancelDiscovery();
		bluetoothAdapter.startDiscovery();
	}

	
	public static boolean isBluetoothPresent() { // Zjitn ptomnosti Bluetooth
		if (bluetoothAdapter != null)
			return true;
		else
			return false;
	}


	public static boolean isBluetoothOn() { // Zjitn zda je Bluetooth zapnuto
		if (bluetoothAdapter.getState() == BluetoothAdapter.STATE_OFF)
			return false;
		else
			return true;
	}

	
	public static void turnOnBluetoothRequest(MainActivity main) { // Vyvoln dosti o zapnut Bluetooth
		main.startActivityForResult(new Intent(
				BluetoothAdapter.ACTION_REQUEST_ENABLE), 1);
	}

	

	public static void cancelDiscovery() { // Zruen vyhledvan
		bluetoothAdapter.cancelDiscovery();
	}

	
	public static void startReceiving(final MainActivity main, // Vyhledvn zazen
			final Handler handler) {
		listOfDevices.clear();
		foundDevices.clear();
		startDiscovery();
	
		receiver = new BroadcastReceiver() {
			@Override
			public void onReceive(Context context, Intent intent) {

				String action = intent.getAction();

				if (BluetoothDevice.ACTION_FOUND.equals(action)) { // Pi nalezen zazen

					BluetoothDevice device = intent
							.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
					foundDevices.add(device);

					listOfDevices.add(device.getName() + "\n"
							+ device.getAddress());

					handler.obtainMessage(1, listOfDevices).sendToTarget();
				}
				else if (BluetoothAdapter.ACTION_DISCOVERY_FINISHED // Pi ukonen hledn
						.equals(action)) {
					handler.obtainMessage(0, new Object()).sendToTarget();
					cancelDiscovery();
					unregReceiver(main);
					return;
				} else if (BluetoothAdapter.ACTION_STATE_CHANGED.equals(action)) { // Pi vypnut Bluetooth
					turnOnBluetoothRequest(main);
				}
				

			}

		};
		registerFilters(main);
	}


	public static void unregReceiver(MainActivity main) { 	// Deregistrace filtr
		try {
			main.unregisterReceiver(receiver);
		} catch (IllegalArgumentException e) {
		}
	}

	
	private static void registerFilters(MainActivity main) { // Registrace filtr akc
		filter = new IntentFilter(BluetoothDevice.ACTION_FOUND);
		main.registerReceiver(receiver, filter);
		filter = new IntentFilter(BluetoothAdapter.ACTION_DISCOVERY_FINISHED);
		main.registerReceiver(receiver, filter);
		filter = new IntentFilter(BluetoothAdapter.ACTION_STATE_CHANGED);
		main.registerReceiver(receiver, filter);
	}

}
