package bluetoothIM.Protocol.Conversations;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.UUID;

import bluetoothIM.Protocol.Routing.RoutingTable;

public class Conversation { // Tda reperezntujc konverzaci

	private HashMap<UUID, Message> ToDeliver;
	private ArrayList<Message> InMessageConversation;
	private String InStringConversation;
	// Get/Set metody
	public HashMap<UUID, Message> getToDeliver() {
		return ToDeliver;
	}

	public void setToDeliver(HashMap<UUID, Message> toDeliver) {
		ToDeliver = toDeliver;
	}

	public ArrayList<Message> getInMessageConversation() {
		return InMessageConversation;
	}

	public void setInMessageConversation(
			ArrayList<Message> inMessageConversation) {
		InMessageConversation = inMessageConversation;
	}

	public String getInStringConversation() {
		return InStringConversation;
	}

	public void setInStringConversation(String inStringConversation) {
		InStringConversation = inStringConversation;
	}

	public Conversation() { // Konstruktor
		ToDeliver = new HashMap<UUID, Message>();
		InMessageConversation = new ArrayList<Message>();
		InStringConversation = "";
	}

	public void refreshConversation() { // Pepotn etzce konverzace
		InStringConversation = "";

		for (Message m : InMessageConversation) {

			if (m.isFromHere() && !m.isDelivered()) {
				InStringConversation += m.getTime() + " " + m.getName()
						+ " says: (not delivered)\n" + m.getText() + "\n";

			} else if (m.isFromHere() && m.isDelivered()) {
				InStringConversation += m.getTime() + " " + m.getName()
						+ " says: (delivered)\n" + m.getText() + "\n";

			} else {
				InStringConversation += m.getTime() + " " + m.getName()
						+ " says: \n" + m.getText() + "\n";
			}
		}
		InStringConversation += "\n\n";
	}

	public void refreshEveryoneConversation() { // Pepotn etzce hromadn konverzace
		InStringConversation = "";

		for (Message m : InMessageConversation) {
			String DeliveredTo = "";
			int i = m.getDeliveredTo().size();
			for (String s : m.getDeliveredTo()) {
				i--;
				DeliveredTo += s;
				if (i != 0)
					DeliveredTo += ", ";

			}

			if (m.isFromHere() && (m.getDeliveredTo().size() == 0)) {
				InStringConversation += m.getTime() + " " + m.getName()
						+ " says: (not delivered)\n" + m.getText() + "\n";

			} else if (m.isFromHere() && (m.getDeliveredTo().size() > 0)) {
				InStringConversation += m.getTime() + " " + m.getName()
						+ " says: (delivered to: " + DeliveredTo + ")\n"
						+ m.getText() + "\n";

			} else {
				InStringConversation += m.getTime() + " " + m.getName()
						+ " says: \n" + m.getText() + "\n";
			}

		}
		InStringConversation += "\n\n";

	}

	public void wasDelivered(UUID deliveredID) { // Nastaven zprvy jako doruen
		if (ToDeliver.containsKey(deliveredID)) {
			ToDeliver.get(deliveredID).deliveredNow();
			ToDeliver.remove(deliveredID);
			refreshConversation();
		}
	}

	public void wasDelivered(String sourceAddress, UUID deliveredID) { // Nastaven hromadn zprvy jako doruen
		if (ToDeliver.containsKey(deliveredID)) {
			ToDeliver.get(deliveredID).deliveredNowTo(RoutingTable.getAddressNamePairs().get(sourceAddress));
			refreshEveryoneConversation();
		}
	}

}
