package bluetoothIM.Protocol.Routing.Packets;

import java.util.UUID;

import android.nfc.FormatException;

public class MessagePacket extends Packet { // Tda se zprvami

	private final int MaxLenghtOrder = 4;
	private int MessageCharCount;
	private String Message;
	private UUID PacketID;

	// Get/Set metody
	public int getMessageCharCount() {
		return MessageCharCount;
	}

	public void setMessageCharCount(int messageCharCount) {
		MessageCharCount = messageCharCount;
	}

	public String getMessage() {
		return Message;
	}

	public void setMessage(String message) {
		Message = message;
	}

	public UUID getPacketID() {
		return PacketID;
	}

	public void setPacketID(UUID packetID) {
		PacketID = packetID;
	}

	public int getMaxLenghtOrder() {
		return MaxLenghtOrder;
	}

	public MessagePacket() {
		Ttl = 64;
	}

	public MessagePacket(String destinationAddress, String sourceAddress,
			String message, UUID packetID) { // Konstruktor
		super(destinationAddress, sourceAddress);
		Message = message;
		MessageCharCount = message.length();
		PacketID = packetID;
	}

	public String getString() { // Metoda vracejc serializovan informace ve form etzce
		String s = String.valueOf(Ttl);
		while (s.length() != getTtlLenght())
			s += '\0';
		return (TypeOfPacket + DestinationAddress + SourceAddress + getCount()
				+ Message + PacketID + s + Trailer);
	}
	@Override
	public Packet getPacket(String toPacket) throws FormatException {  // Zskn dat z etzce
		MessagePacket p = new MessagePacket();
		p.TypeOfPacket = toPacket.charAt(0);
		p.DestinationAddress = toPacket.substring(p.TypeLenght, p.TypeLenght
				+ p.AddressLenght);
		p.SourceAddress = toPacket.substring(p.TypeLenght + p.AddressLenght,
				p.TypeLenght + p.AddressLenght + p.AddressLenght);
		p.MessageCharCount = Integer.parseInt(toPacket.substring(
				p.TypeLenght + 2 * p.AddressLenght,
				p.TypeLenght + 2 * p.AddressLenght + p.MaxLenghtOrder).replace(
				p.B, ""));
		p.Message = toPacket.substring(p.TypeLenght + 2 * p.AddressLenght
				+ p.MaxLenghtOrder, p.TypeLenght + 2 * p.AddressLenght
				+ p.MaxLenghtOrder + p.MessageCharCount);
		p.PacketID = UUID.fromString(toPacket.substring(p.TypeLenght + 2
				* p.AddressLenght + p.MaxLenghtOrder + p.MessageCharCount,
				p.TypeLenght + 2 * p.AddressLenght + p.MaxLenghtOrder
						+ p.MessageCharCount + p.UUIDLenght));
		p.Ttl = Integer.parseInt(toPacket.substring(
				p.TypeLenght + 2 * p.AddressLenght + p.MaxLenghtOrder
						+ p.MessageCharCount + p.UUIDLenght,
				p.TypeLenght + 2 * p.AddressLenght + p.MaxLenghtOrder
						+ p.MessageCharCount + p.UUIDLenght + TtlLenght)
				.replace(p.B, ""));
		if (p.Trailer.equals(toPacket.substring(p.TypeLenght + 2
				* p.AddressLenght + p.MaxLenghtOrder + p.MessageCharCount
				+ p.UUIDLenght + TtlLenght, p.TypeLenght + 2 * p.AddressLenght
				+ p.MaxLenghtOrder + p.MessageCharCount + p.UUIDLenght
				+ TtlLenght + p.Trailer.length()))) {
			return p;
		} else {
			throw new FormatException();
		}
	}

	private String getCount() {
		String c = String.valueOf(MessageCharCount);
		while (c.length() != MaxLenghtOrder)
			c += B;
		return c;
	}

}
