package bluetoothIM.Protocol.Routing.Packets;

import java.util.ArrayList;
import java.util.HashMap;
import android.nfc.FormatException;

public class UpdatePacket extends Packet { // Paket s informacemi o topologii


	private int AddressAddressPairCount;
	private HashMap<String, ArrayList<String>> AddressAddressPair;
	private int AddressNamePairCount;
	private HashMap<String, String> AddressNamePair;
	

	public int getAddressAddressPairCount() {
		return AddressAddressPairCount;
	}

	public void setAddressAddressPairCount(int addressAddressPairCount) {
		AddressAddressPairCount = addressAddressPairCount;
	}

	public HashMap<String, ArrayList<String>> getAddressAddressPair() {
		return AddressAddressPair;
	}

	public void setAddressAddressPair(
			HashMap<String, ArrayList<String>> addressAddressPair) {
		AddressAddressPair = addressAddressPair;
	}

	public int getAddressNamePairCount() {
		return AddressNamePairCount;
	}

	public void setAddressNamePairCount(int addressNamePairCount) {
		AddressNamePairCount = addressNamePairCount;
	}

	public HashMap<String, String> getAddressNamePair() {
		return AddressNamePair;
	}

	public void setAddressNamePair(HashMap<String, String> addressNamePair) {
		AddressNamePair = addressNamePair;
	}




	public UpdatePacket() {
		Ttl = 64;
		AddressAddressPair = new HashMap<String, ArrayList<String>>();
		AddressNamePair = new HashMap<String, String>();
	}

	public String getString() { // Metoda vracejc serializovan informace ve form etzce
		String s = String.valueOf(Ttl);
		while (s.length() != getTtlLenght())
			s += '\0';
		return (TypeOfPacket + DestinationAddress + SourceAddress
				+ GetUpdateInfo() + s + Trailer);
	}
	@Override
	public Packet getPacket(String toPacket) throws FormatException {  // Zskn dat z etzce
		UpdatePacket p = new UpdatePacket();
		p.TypeOfPacket = toPacket.charAt(0);
		p.DestinationAddress = toPacket.substring(p.TypeLenght, p.TypeLenght
				+ p.AddressLenght);
		p.SourceAddress = toPacket.substring(p.TypeLenght + p.AddressLenght,
				p.TypeLenght + p.AddressLenght + p.AddressLenght);
		p.AddressAddressPairCount = Integer.parseInt(toPacket.substring(
				p.TypeLenght + 2 * p.AddressLenght,
				p.TypeLenght + 2 * p.AddressLenght + p.HashMapMaxLenghtOrder)
				.replace(p.B, ""));
		p.AddressAddressPair = p.getAddressAddressPair(toPacket);
		p.AddressNamePairCount = Integer.parseInt(toPacket.substring(
				p.TypeLenght + 2 * p.AddressLenght + p.HashMapMaxLenghtOrder
						+ p.AddressAddressPairCount * 2 * p.AddressLenght,
				p.TypeLenght + 2 * p.AddressLenght + p.HashMapMaxLenghtOrder
						+ p.AddressAddressPairCount * 2 * p.AddressLenght
						+ p.HashMapMaxLenghtOrder).replace(p.B, ""));
		p.AddressNamePair = p.getAddressNamePair(toPacket, p.TypeLenght + 2
				* p.AddressLenght + p.HashMapMaxLenghtOrder
				+ p.AddressAddressPairCount * 2 * p.AddressLenght
				+ p.HashMapMaxLenghtOrder);
		
		p.Ttl = Integer.parseInt(toPacket.substring(TypeLenght + 2
				* p.AddressLenght + 2 * p.HashMapMaxLenghtOrder
				+ p.AddressAddressPairCount * 2 * p.AddressLenght
				+ p.AddressNamePairCount * (p.AddressLenght + p.NameLenght),
				TypeLenght + 2 * p.AddressLenght + 2 * p.HashMapMaxLenghtOrder
						+ p.AddressAddressPairCount * 2 * p.AddressLenght
						+ p.AddressNamePairCount
						* (p.AddressLenght + p.NameLenght) + p.TtlLenght).replace(p.B, ""));
		if (p.Trailer.equals((toPacket.substring(TypeLenght + 2
				* p.AddressLenght + 2 * p.HashMapMaxLenghtOrder
				+ p.AddressAddressPairCount * 2 * p.AddressLenght
				+ p.AddressNamePairCount * (p.AddressLenght + p.NameLenght)
				+ p.TtlLenght , TypeLenght + 2 * p.AddressLenght
				+ 2 * p.HashMapMaxLenghtOrder + p.AddressAddressPairCount * 2
				* p.AddressLenght + p.AddressNamePairCount
				* (p.AddressLenght + p.NameLenght)  + p.TtlLenght
				+ p.Trailer.length())))) {
			return p;
		} else {
			throw new FormatException();
		}
	}

	private HashMap<String, String> getAddressNamePair(String toPacket, int from) {  // Zskn dvojit adresa - jmno
		HashMap<String, String> tmp = new HashMap<String, String>();
		for (int i = 0; i < AddressNamePairCount; i++) {
			tmp.put(toPacket.substring(from + i * (AddressLenght + NameLenght),
					from + i * (AddressLenght + NameLenght) + AddressLenght),
					toPacket.substring(
							from + i * (AddressLenght + NameLenght)
									+ AddressLenght,
							from + i * (AddressLenght + NameLenght)
									+ AddressLenght + NameLenght)
							.replace(B, ""));
		}
		return tmp;
	}

	private HashMap<String, ArrayList<String>> getAddressAddressPair(
			String toPacket) {   // Zskn topologie st z informac v paketu
		HashMap<String, ArrayList<String>> tmp = new HashMap<String, ArrayList<String>>();
		for (int i = 0; i < AddressAddressPairCount; i++) {
			if (!tmp.containsKey(toPacket.substring(TypeLenght + 2
					* AddressLenght + HashMapMaxLenghtOrder + i * 2
					* AddressLenght, TypeLenght + 2 * AddressLenght
					+ HashMapMaxLenghtOrder + i * 2 * AddressLenght
					+ AddressLenght))) {
				tmp.put(toPacket.substring(TypeLenght + 2 * AddressLenght
						+ HashMapMaxLenghtOrder + i * 2 * AddressLenght,
						TypeLenght + 2 * AddressLenght + HashMapMaxLenghtOrder
								+ i * 2 * AddressLenght + AddressLenght),
						new ArrayList<String>());
			}
			tmp.get(toPacket.substring(TypeLenght + 2 * AddressLenght
					+ HashMapMaxLenghtOrder + i * 2 * AddressLenght, TypeLenght
					+ 2 * AddressLenght + HashMapMaxLenghtOrder + i * 2
					* AddressLenght + AddressLenght)).add(
					toPacket.substring(TypeLenght + 2 * AddressLenght
							+ HashMapMaxLenghtOrder + i * 2 * AddressLenght
							+ AddressLenght, TypeLenght + 2 * AddressLenght
							+ HashMapMaxLenghtOrder + i * 2 * AddressLenght
							+ AddressLenght + AddressLenght));

		}
		return tmp;
	}

	private String GetUpdateInfo() { // Serializace smrovacch dat do etzce 
		if(TypeOfPacket!='d')
		{
		AddressAddressPairCount = 0;
		for(String s : AddressAddressPair.keySet())
		{
			for(@SuppressWarnings("unused") String t : AddressAddressPair.get(s))
			{
				AddressAddressPairCount++;
				
			}
		}
		AddressNamePairCount = 0;
		for(@SuppressWarnings("unused") String t : AddressNamePair.keySet())
		{
			AddressNamePairCount++;
			
		}
		}
		String x = String.valueOf(AddressAddressPairCount);
		String r = "";
		while (x.length() != HashMapMaxLenghtOrder)
			x += B;
		r += x;
		for (String s : AddressAddressPair.keySet()) {
			for (String t : AddressAddressPair.get(s)) {
				r += s;
				r += t;
			}
		}
	
		x = String.valueOf(AddressNamePairCount);
		while (x.length() != HashMapMaxLenghtOrder)
			x += B;
		r += x;
		for (String u : AddressNamePair.keySet()) {
			r += u;
			r += getName(AddressNamePair.get(u));
		}
		return r;
	}

	private String getName(String name) { // Unifikace dlky jmna
		String uname = "";
        for (int i = 0; i < name.length(); i++ )
        {
            uname+=name.charAt(i);
        }
        while (uname.length() != NameLenght)
            uname += B;

        return uname;
	}

}
