package bluetoothIM.Protocol.Routing;

import java.util.ArrayList;
import java.util.HashMap;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothSocket;

public class RoutingAlgorithm { // Tda pro vpoet cest
	   public static void run() // Metoda, ve kter b algoritmus pro vpoet cesty
       {
		  
           RoutingTable.getTable().clear();
           ArrayList<String> toFind = new ArrayList<String>();
           for(String s : RoutingTable.getAddressNamePairs().keySet())
        	   toFind.add(s);
           HashMap<String, HashMap<BluetoothSocket,Integer>> costTable = new HashMap<String, HashMap<BluetoothSocket,Integer>>();
           HashMap<String, ArrayList<String>> topology = new HashMap<String, ArrayList<String>>();
           getTopology(topology);
           toFind.remove(BluetoothAdapter.getDefaultAdapter().getAddress());
           
           for (String a : RoutingTable.getAddressDirectlyConnectedPairs().keySet())  // Vechna pmo pipojen zazen jsou pidna do tabulky
           {
               if (toFind.contains(a))
               {
                   RoutingTable.addToTable(a, RoutingTable.getAddressDirectlyConnectedPairs().get(a)); 
                   toFind.remove(a);
               }
           }
           if(toFind.size() == 0) // Pokud jsou vichni pmo pipojen je vpoet ukonen
           {
        	   setTable(costTable);
               return;
           }
           for (String a : RoutingTable.getAddressDirectlyConnectedPairs().keySet())  // Pro kadho souseda je sputno vyhledvn ve stromu
           {
        	   int i = 1;
               getTopology(topology);
               removeDirectlyConnected(topology);
               if (toFind.size() != 0)
                   find(toFind, topology, a, a,RoutingTable.getAddressDirectlyConnectedPairs().get(a), i, costTable);
             
           }
           setTable(costTable);
           
           
       }
       private static void setTable(  // Zkoprovn doasn tabulky do vsledn
			HashMap<String, HashMap< BluetoothSocket,Integer>> costTable) {
    	   for (String s : costTable.keySet())
           {
               for (BluetoothSocket r : costTable.get(s).keySet())
                {
            	   if(!RoutingTable.getTable().containsKey(s))
            	   	RoutingTable.getTable().put(s, r);
               }
           }
		
	}
	private static void getTopology(HashMap<String, ArrayList<String>> topology) { // Vytvoen topologie pro vpoet
    	   for(String s : RoutingTable.getAddressListAddressPairs().keySet())
           {
               topology.put(s, new ArrayList<String>());
               for (String p : RoutingTable.getAddressListAddressPairs().get(s))
               {
                   topology.get(s).add(p);
               }
           }
           
           removeNode(topology, BluetoothAdapter.getDefaultAdapter().getAddress());
		
	}
	private static void find(ArrayList<String> toFindList, HashMap<String, ArrayList<String>>  topology,  
			String node, String hop, BluetoothSocket client, int i, HashMap<String, HashMap< BluetoothSocket,Integer>> costTable)  // Prohledvn topologie a pidvn nalezench cest do tabulky
       {		
           if (topology.get(node).size() != 0)
           {
               for (String a : topology.get(node))
               {
                   if (toFindList.contains(a))
                   {
                	   		if(!costTable.containsKey(a))  // Pokud je nalezena krat cesta je pidna do doasn tabulky
                           costTable.put(a, new HashMap<BluetoothSocket, Integer>()); 
                           if (!costTable.get(a).containsKey(client))
                               costTable.get(a).put(client,i); 
                           if (costTable.get(a).get(client) > i)
                           {
                       costTable.get(a).put(client,i);
                        
                           }
                   }
                   removeNode(topology, node); // Odebrn zpten cesty 
                   find(toFindList, topology, a, hop, client, i, costTable); // Pro kadho souseda sputn znovu
               }

           }
           else
               return;

       }
       private static void removeNode(HashMap<String, ArrayList<String>> topology, String node) // Odstrann uzlu z topologie
       {
           topology.remove(node);
           for (String a : topology.keySet())
           {
               if (topology.get(a).contains(node))
               {
                  topology.get(a).remove(node);
               }
           }

       }
       private static void removeDirectlyConnected(HashMap<String, ArrayList<String>> topology)
       {
    	   
    	   for (String b : RoutingTable.getAddressDirectlyConnectedPairs().keySet())
           {
           
           for (String a : topology.keySet())
           {
               if (topology.get(a).contains(b))
               {
                   topology.get(a).remove(b);
               }
           }
           }
       }
    
       
}
