package bluetoothIM.Protocol.Routing;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.UUID;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothSocket;
import android.nfc.FormatException;
import bluetoothIM.Controller.ViewController;
import bluetoothIM.Protocol.Connections.InputOutput;
import bluetoothIM.Protocol.Conversations.Conversation;
import bluetoothIM.Protocol.Conversations.Room;
import bluetoothIM.Protocol.Routing.Packets.AcknowledgementPacket;
import bluetoothIM.Protocol.Routing.Packets.MessagePacket;
import bluetoothIM.Protocol.Routing.Packets.Packet;
import bluetoothIM.Protocol.Routing.Packets.UpdatePacket;

public class RoutingHandler   // Tda zajiujc smrovn
{
	public static ArrayList<String> deleted;
	
	static  // Konstruktor
	{
		deleted = new ArrayList<String>();
		
	}
	public static void routePacket(String packet, BluetoothSocket socket)  // Smrovn paket
			throws Exception {
	
		
		switch (packet.charAt(0)) {
		case 'a':
			routeMessagePacket(packet, socket);
			break;
		case 'b':
			routeAckPacket(packet, socket);
			break;
		case 'c':
			routeUpdatePacket(packet, socket);
			break;
		case 'd':
			routeUpdateDeletePacket(packet, socket);
			break;
		case 'e':
			routeMessagePacket(packet, socket);
			break;
		case 'f':
			routeAckPacket(packet, socket);
			break;
		default:
			badPacketReceived(socket.getRemoteDevice().getAddress());
			break;
		}

	}

	private static void routeMessagePacket(String packet, BluetoothSocket socket) // Zpracovn zprvy
		{
		try{
		MessagePacket msg = new MessagePacket();
		msg = (MessagePacket)msg.getPacket(packet);

		if (msg.getDestinationAddress().equals(
				BluetoothAdapter.getDefaultAdapter().getAddress()))
		{
			if (msg.getTypeOfPacket() == 'e')
				Room.newMessageReceived("Everyone", RoutingTable
						.getAddressNamePairs().get(msg.getSourceAddress()), msg
						.getMessage(), msg.getPacketID());
			else
				Room.newMessageReceived(msg.getSourceAddress(), RoutingTable
						.getAddressNamePairs().get(msg.getSourceAddress()), msg
						.getMessage(), msg.getPacketID());
			sendAck(msg);

		} else
			ReSend(msg);
		}
		catch(FormatException e)
		{
			badPacketReceived(socket.getRemoteDevice().getAddress());
		}
	}

	private static void routeAckPacket(String packet, BluetoothSocket socket) // Zpracovn potvrzen
		{
		try{
		AcknowledgementPacket ack = new AcknowledgementPacket();
		ack = (AcknowledgementPacket)ack.getPacket(packet);
		
		
		if (ack.getDestinationAddress().equals(
				BluetoothAdapter.getDefaultAdapter().getAddress())) 
		{
			if (ack.getTypeOfPacket() == 'f') {
				Room.delivered("Everyone", ack.getSourceAddress(),
						ack.getPacketID());
			} else {
				Room.delivered(ack.getSourceAddress(), ack.getPacketID());
			}
		} else
			ReSend(ack);
		}
		catch(FormatException e)
		{
			badPacketReceived(socket.getRemoteDevice().getAddress());
		}
	}

	
	private static void routeUpdatePacket(String packet, BluetoothSocket socket) { // Zpracovn smrovacch informac
		UpdatePacket upd = new UpdatePacket();
		try {
			upd = (UpdatePacket)upd.getPacket(packet);
		} catch (FormatException e) {

		
				badPacketReceived(socket.getRemoteDevice().getAddress());
		}
		if (upd.getDestinationAddress().equals(
				BluetoothAdapter.getDefaultAdapter().getAddress())) 
		{
			for (String s : upd.getAddressAddressPair().keySet()) {
				for (String t : upd.getAddressAddressPair().get(s)) {
					if (RoutingTable.getAddressListAddressPairs()
							.containsKey(s)
							&& !RoutingTable.getAddressListAddressPairs()
									.get(s).contains(t))
						RoutingTable.getAddressListAddressPairs().get(s).add(t);
					if (!RoutingTable.getAddressListAddressPairs().containsKey(
							s)) {
						RoutingTable.getAddressListAddressPairs().put(s,
								new ArrayList<String>());
						if (!RoutingTable.getAddressListAddressPairs().get(s)
								.contains(t)) {

							RoutingTable.getAddressListAddressPairs().get(s)
									.add(t);
						}
					}
				}

			}
			ArrayList<String> toSendBack = new ArrayList<String>();
			for (String t : upd.getAddressNamePair().keySet()) {
				if (!RoutingTable.getAddressNamePairs().containsKey(t)) {
					RoutingTable.getAddressNamePairs().put(t,
							upd.getAddressNamePair().get(t));
						toSendBack.add(t);
						if(RoutingHandler.deleted.contains(socket.getRemoteDevice().getAddress()))
							RoutingHandler.deleted.remove(socket.getRemoteDevice().getAddress());
				}
			}
			for (String t : upd.getAddressNamePair().keySet()) {
				if (!RoutingTable.getNameAddressPairs().containsKey(
						upd.getAddressNamePair().get(t))) {
					RoutingTable.getNameAddressPairs().put(
							upd.getAddressNamePair().get(t), t);

				}
			}
			for (String t : upd.getAddressNamePair().keySet()) {
				if (!RoutingTable.getMemberNames().contains(
						upd.getAddressNamePair().get(t))) {
					RoutingTable.getMemberNames().add(
							upd.getAddressNamePair().get(t));

				}
			}
			for (String t : upd.getAddressNamePair().keySet()) {
				if (!Room.getConversations().containsKey(t))
					Room.getConversations().put(t, new Conversation());

			}
			Room.getRoomMembers();
			RoutingAlgorithm.run();
			for(String s : toSendBack)
			{
				SendUpdate(s);
			}
			
		} else
			ReSend(upd);

	}

	private static void routeUpdateDeletePacket(String packet,
			BluetoothSocket socket) {								// Zpracovn informac o zruen spojen
		UpdatePacket upd = new UpdatePacket();
		try {
			upd = (UpdatePacket)upd.getPacket(packet);
		} catch (FormatException e) {
			
				badPacketReceived(socket.getRemoteDevice().getAddress());
			
		}
		if (upd.getDestinationAddress().equals(
				BluetoothAdapter.getDefaultAdapter().getAddress()))
		{

			ArrayList<String> l = new ArrayList<String>();
		for(String s : upd.getAddressAddressPair().keySet())
		{
			l.add(s);
		}
			removeLink(l.get(0), l.get(1));
			RoutingAlgorithm.run();
			Room.getRoomMembers();
			
		} else
			ReSend(upd);

	}

	private static void SendDeleteUpdate(String addressOne, String addressTwo,
			String address) { 														// Zasln informace o zruen spojen
		HashMap<String, ArrayList<String>> d = new HashMap<String, ArrayList<String>>();
		d.put(addressOne, new ArrayList<String>());
		d.get(addressOne).add(addressTwo);
		d.put(addressTwo, new ArrayList<String>());
		d.get(addressTwo).add(addressOne);
		UpdatePacket p = new UpdatePacket();
		p.setTypeOfPacket('d');
		p.setAddressAddressPair(d);
		p.setAddressNamePair(new HashMap<String, String>());
		p.setDestinationAddress(address);
		p.setSourceAddress(BluetoothAdapter.getDefaultAdapter().getAddress());
		p.setAddressNamePairCount(0);
		p.setAddressAddressPairCount(2);
		p.setPacketID(UUID.randomUUID());
		p.setTtl(64);
		
		sendToDestination(p.getDestinationAddress(), p.getString());
	}

	public static void badPacketReceived(String address) { // Metoda ec pjem patnho paketu
		ArrayList<String> keys =  new ArrayList<String>();
		for (String s : RoutingTable.getTable().keySet())
			keys.add(s);
		if (!deleted.contains(address))
         {
             deleted.add(address);
		for (String s : keys) {
			if (s!=address)
				SendDeleteUpdate(BluetoothAdapter.getDefaultAdapter()
						.getAddress(), address, s);
		}
		if(RoutingTable.getAddressNamePairs().containsKey(address))
		{
		String s = RoutingTable.getAddressNamePairs().get(address)+ " has been disconnected";
		ViewController.handler.obtainMessage(-2, s).sendToTarget();
		}
		removeClient(address);
         }
		
	}

	private static void removeClient(String address) { // Odstrann z odpojenho souseda z topologie
		RoutingTable.removeAddressListAddressPair(address, BluetoothAdapter.getDefaultAdapter().getAddress());
		RoutingTable.removeAddressDirectlyConnectedPair(address);
		RoutingAlgorithm.run();
		ArrayList<String> nameCopy = new ArrayList<String>();
		for(String s : RoutingTable.getAddressNamePairs().keySet())
        {
        nameCopy.add(s);
        }
		for(String s : nameCopy)
		{
		if(!RoutingTable.getTable().keySet().contains(s) && !BluetoothAdapter.getDefaultAdapter().getAddress().equals(s))
		{
		ViewController.handler.obtainMessage(-4, RoutingTable.getAddressNamePairs().get(s)+"has left room");
		 RoutingTable.getAddressListAddressPairs().remove(s);
		RoutingTable.removeNameAddressPair(RoutingTable.getAddressNamePairs().get(s));
		RoutingTable.removeMemberName(RoutingTable.getAddressNamePairs().get(s));
		Room.getConversations().remove(s);
		RoutingTable.removeAddressNamePair(s);
		}
		}
		  
		Room.getRoomMembers();
		
	
	}

	private static void sendToDestination(String address, String packet) { // Odesln paketu
		 if (address != null &&  RoutingTable.getTable().containsKey(address))
         {
		InputOutput.write(RoutingTable.getTable().get(address), packet);
         }
	}

	public static void SendUpdate(String address) // Zasln smrovacch informac
	{
		UpdatePacket p = new UpdatePacket();
		p.setAddressAddressPair(RoutingTable.getAddressListAddressPairs());
		p.setTypeOfPacket('c');

		p.setAddressNamePair(RoutingTable.getAddressNamePairs());
		p.setSourceAddress(BluetoothAdapter.getDefaultAdapter().getAddress());
		p.setDestinationAddress(address);
		p.setSourceAddress(BluetoothAdapter.getDefaultAdapter().getAddress());
		p.setAddressNamePairCount(RoutingTable.getAddressNamePairs().size());
		p.setAddressAddressPairCount(RoutingTable.getCount());
		p.setPacketID(UUID.randomUUID());
		p.setTtl(64);
		
		sendToDestination(p.getDestinationAddress(), p.getString());
	}

	

	public static void sendMessageTo(String toAddress, String text, UUID uuid) { // Odesln zprvy

		MessagePacket p = new MessagePacket();
		try
		{
		if (toAddress == "Everyone") {
			for (String s : RoutingTable.getTable().keySet()) {
				p.setTypeOfPacket('e');
				p.setMessage(text);
				p.setDestinationAddress(s);
				p.setSourceAddress(BluetoothAdapter.getDefaultAdapter()
						.getAddress());
				p.setMessageCharCount(text.length());
				p.setPacketID(uuid);
				p.setTtl(64);
				sendToDestination(p.getDestinationAddress(), p.getString());
			}
		} else {
			p.setTypeOfPacket('a');
			p.setMessage(text);
			p.setDestinationAddress(toAddress);
			p.setSourceAddress(BluetoothAdapter.getDefaultAdapter()
					.getAddress());
			p.setMessageCharCount(text.length());
			p.setPacketID(uuid);
			p.setTtl(64);
			sendToDestination(p.getDestinationAddress(), p.getString());
		}
		}
		catch(Exception e)
		{}
	}

	private static void removeLink(String addressOne, String addressTwo) { // Odstrann spojen z topologie

		  RoutingTable.removeAddressListAddressPair(addressOne, addressTwo);
          RoutingAlgorithm.run();
          ArrayList<String> nameCopy = new ArrayList<String>();
  		for(String s : RoutingTable.getAddressNamePairs().keySet())
          {
          nameCopy.add(s);
          }
  		for(String s : nameCopy)
  		{
  		if(!RoutingTable.getTable().keySet().contains(s) && !BluetoothAdapter.getDefaultAdapter().getAddress().equals(s))
  		{
  		ViewController.handler.obtainMessage(-4, RoutingTable.getAddressNamePairs().get(s)+"has left room");
  		 RoutingTable.getAddressListAddressPairs().remove(s);
  		RoutingTable.removeNameAddressPair(RoutingTable.getAddressNamePairs().get(s));
  		RoutingTable.removeMemberName(RoutingTable.getAddressNamePairs().get(s));
  		Room.getConversations().remove(s);
  		RoutingTable.removeAddressNamePair(s);
  		}
  		}
  		
  		Room.getRoomMembers();
	}

	private static void ReSend(Packet packet) { // Peposln paketu
		packet.setTtl(packet.getTtl() - 1);
		sendToDestination(packet.getDestinationAddress(), packet.getString()); 
	}

	private static void sendAck(Packet packet) { // Zasln potvrzen
		AcknowledgementPacket ack = new AcknowledgementPacket();
		if (packet.getTypeOfPacket() == 'e')
			ack.setTypeOfPacket('f');
		else
			ack.setTypeOfPacket('b');
		ack.setSourceAddress(BluetoothAdapter.getDefaultAdapter().getAddress());
		ack.setDestinationAddress(packet.getSourceAddress());
		ack.setPacketID(packet.getPacketID());
		ack.setTtl(64);
		sendToDestination(ack.getDestinationAddress(), ack.getString());
	}
}
