package bluetoothIM.Protocol.Routing;

import java.util.ArrayList;
import java.util.HashMap;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothSocket;

public class RoutingTable {  // Tda reprezentujc smrovac tabulku

		private static HashMap<String, ArrayList<String>> AddressListAddressPairs;
		private  static HashMap<String, String> AddressNamePairs;
		private  static HashMap<String, String> NameAddressPairs;
		private static HashMap<String, BluetoothSocket> AddressDirectlyConnectedPairs;
		private  static HashMap<String, BluetoothSocket> Table;
		private  static ArrayList<String> MemberNames;
		
		// Get/Set metody
	public  static HashMap<String, ArrayList<String>> getAddressListAddressPairs() {
		return AddressListAddressPairs;
	}
	public static void setAddressListAddressPairs(
			HashMap<String, ArrayList<String>> addressListAddressPairs) {
		AddressListAddressPairs = addressListAddressPairs;
	}
	public static HashMap<String, String> getAddressNamePairs() {
		return AddressNamePairs;
	}
	public static void setAddressNamePairs(HashMap<String, String> addressNamePairs) {
		AddressNamePairs = addressNamePairs;
	}
	public static HashMap<String, String> getNameAddressPairs() {
		return NameAddressPairs;
	}
	public static void setNameAddressPairs(HashMap<String, String> nameAddressPairs) {
		NameAddressPairs = nameAddressPairs;
	}
	public static HashMap<String, BluetoothSocket> getAddressDirectlyConnectedPairs() {
		return AddressDirectlyConnectedPairs;
	}
	public static void setAddressDirectlyConnectedPairs(
			HashMap<String, BluetoothSocket> addressDirectlyConnectedPairs) {
		AddressDirectlyConnectedPairs = addressDirectlyConnectedPairs;
	}
	public static HashMap<String, BluetoothSocket> getTable() {
		return Table;
	}
	public static void setTable(HashMap<String, BluetoothSocket> table) {
		Table = table;
	}
	
	public static ArrayList<String> getMemberNames() {
		return MemberNames;
	}
	public static void setMemberNames(ArrayList<String> memberNames) {
		MemberNames = memberNames;
	}
       static // Konstruktor
       {
           AddressListAddressPairs = new HashMap<String, ArrayList<String>>();
           AddressNamePairs = new HashMap<String, String>();
           AddressNamePairs.put(BluetoothAdapter.getDefaultAdapter().getAddress(), BluetoothAdapter.getDefaultAdapter().getName());
           NameAddressPairs = new HashMap<String, String>();
           NameAddressPairs.put(BluetoothAdapter.getDefaultAdapter().getName(), BluetoothAdapter.getDefaultAdapter().getAddress());
           AddressDirectlyConnectedPairs = new HashMap<String, BluetoothSocket>();
           Table = new HashMap<String, BluetoothSocket>();
           MemberNames = new ArrayList<String>();
           addMemberName(BluetoothAdapter.getDefaultAdapter().getName());
       }

       public static void addAddressListAddressPair(String addressOne, String addressTwo)   // Metody pro pidvn a odebrn zazen ze slovnk
       {
           if (!AddressListAddressPairs.containsKey(addressOne))
           {
               AddressListAddressPairs.put(addressOne, new ArrayList<String>());
           }  
           AddressListAddressPairs.get(addressOne).add(addressTwo);
           if (!AddressListAddressPairs.containsKey(addressTwo))
           {     
        	   AddressListAddressPairs.put(addressTwo, new ArrayList<String>());
          
           } 
           AddressListAddressPairs.get(addressTwo).add(addressOne);
       } 
       public static void removeAddressListAddressPair(String addressOne, String addressTwo)
       {
    	   if (AddressListAddressPairs.containsKey(addressOne))
           {
               AddressListAddressPairs.get(addressOne).remove(addressTwo);
               if (AddressListAddressPairs.get(addressOne).size() == 0)
                   AddressListAddressPairs.remove(addressOne);
           }


           if (AddressListAddressPairs.containsKey(addressTwo))
           {
              AddressListAddressPairs.get(addressTwo).remove(addressOne);
               if (AddressListAddressPairs.get(addressTwo).size() == 0)
                   AddressListAddressPairs.remove(addressTwo);
           }
       }
       public static void addAddressNamePair(String address, String name)
       {
           if (!AddressNamePairs.containsKey(address))
               AddressNamePairs.put(address, name);
       }
       public static void removeAddressNamePair(String address)
       {
    	   if (AddressNamePairs.containsKey(address) && !AddressListAddressPairs.containsKey(address))
               AddressNamePairs.remove(address);
       }
       public static void addNameAddressPair(String name, String address)
       {
           if (!NameAddressPairs.containsKey(name))
               NameAddressPairs.put(name, address);
       }
       public static void removeNameAddressPair(String name)
       {
    	   if (NameAddressPairs.containsKey(name) && !AddressListAddressPairs.containsKey(NameAddressPairs.get(name)))
               NameAddressPairs.remove(name);
       }
       
       public static void addAddressDirectlyConnectedPair(String address, BluetoothSocket client)
       {
           if (!AddressDirectlyConnectedPairs.containsKey(address))
               AddressDirectlyConnectedPairs.put(address, client);
       }
       public static void removeAddressDirectlyConnectedPair(String address)
       {
    	   if (AddressDirectlyConnectedPairs.containsKey(address))
               AddressDirectlyConnectedPairs.remove(address);
       }
       public static void addToTable(String address, BluetoothSocket client)
       {
           if (!Table.containsKey(address))
               Table.put(address, client);
       }
       public static void removeFromTable(String address)
       {
           if (Table.containsKey(address))
               Table.remove(address);
       }

       
       public static void addMemberName(String name)
       {
           if (!MemberNames.contains(name))
           {
               MemberNames.add(name);
           }
       }
       public static void removeMemberName(String name)
       {
           if (MemberNames.contains(name))
           {
               MemberNames.remove(name);
           }
       }
       public static int getCount() {
   		int i = 0;
   		for (String s : RoutingTable.getAddressListAddressPairs().keySet()) {
   			for (@SuppressWarnings("unused")String t : RoutingTable.getAddressListAddressPairs().get(s)) {
   				i++;
   			}
   		}
   		return i;

   	}
}
