package bluetoothIM.View;


import java.io.IOException;

import bluetoothIM.Controller.ViewController;
import bluetoothIM.Protocol.Connections.InputOutput;
import bluetoothIM.Protocol.Connections.Scanning;
import bluetoothIM.Protocol.Routing.RoutingTable;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.content.Intent;
import android.os.Bundle;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;


public class MainActivity extends Activity // Hlavn tda
{
	ViewController controller;
	@Override
	protected void onCreate(Bundle savedInstanceState)  // Pi startu aplikace
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		InputOutput.main = this;
		if (BluetoothAdapter.getDefaultAdapter() == null) {
			Toast.makeText(
					getApplicationContext(),
					"Toto zazen nepodporuje bluetooth, aplikace bude ukonena",
					Toast.LENGTH_LONG).show();
			finish();
		}
				 if(!BluetoothAdapter.getDefaultAdapter().isEnabled())
		          {
					   Scanning.turnOnBluetoothRequest(this);
		             
		          }
		
				 else
			  {
		
				setController();
			  }
			 
		  }


	
	
	private void setController() // Pedn prvk uivatelskho rozhran
	{
		TextView status = (TextView) findViewById(R.id.Conversation);
		status.setText("ROOM IS EMPTY");
		controller = new ViewController(
				(ScrollView) findViewById(R.id.Scroll),
				(TextView) findViewById(R.id.Conversation),
				(Button)findViewById(R.id.Send),
				(Spinner) findViewById(R.id.Members),
				(ListView) findViewById(R.id.InRange),
				(TextView) findViewById(R.id.Input),
				(EditText) findViewById(R.id.Output),
				(Button)findViewById(R.id.Scan),this
				);
	}
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data); // Zpracovn vsledku dialogu
		if (resultCode == RESULT_CANCELED) {
			
			
			while(true)
			{
			
				if(BluetoothAdapter.getDefaultAdapter().isEnabled())
				{
					
				
				setController();
				break;
				
				}
			}
		}
		if(resultCode == RESULT_OK)
		{
			
			setController();
		}
	}
	@Override
	protected void onStop() {
	for(String s : RoutingTable.getTable().keySet())
	{
		
		controller.close();
	}
	super.onStop();
	}
}