﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using InTheHand;
using InTheHand.Net.Bluetooth;
using InTheHand.Net.Ports;
using InTheHand.Net.Sockets;
using System.Threading;
using System.IO;
using System.Net.Sockets;
using BluetoothIM.Model.Protocol.Conversations;
namespace BluetoothIM.Model.Protocol.Connections
{
    public class Connecting // Třída k vytvoření spojení
    {
        private Guid mUUID = new Guid("00001101-0000-1000-8000-00805F9B34FB");
        private BluetoothDeviceInfo deviceInfo;
        private string myPin = "1234";

        public Connecting(BluetoothDeviceInfo DeviceInfo) // Konstruktor
        {
            deviceInfo = DeviceInfo;
        }
        public void connectToDevice() // Metoda sloužící spouštějící vlákno pro připojení
        {
            if (pairDevice())
            {
                Thread bluetoothClientThread = new Thread(new ThreadStart(ClientConnectThread));
                bluetoothClientThread.Start();
            }
            else
            {
                Room.failed();
            }

        }
        private void ClientConnectThread() // Metoda inicializující spojení
        {
            BluetoothClient client = new BluetoothClient();
            client.BeginConnect(deviceInfo.DeviceAddress, mUUID, this.BluetoothClientConnectCallback, client);
        }
        private void BluetoothClientConnectCallback(IAsyncResult result) // Metoda zpracovávající výsledky spojení
        {
            try
            {
                BluetoothClient client = (BluetoothClient)result.AsyncState;
                client.EndConnect(result);
                Room.onConnect(client);
                
            }
            catch (SocketException)
            {
                Room.Status = "Connection\nwas not succesfull";
                Room.status();
            }

        }
        private bool pairDevice() // Ověření zda jsou zařízení spárovaná
        {

            if (!deviceInfo.Authenticated)
            {
                if (!BluetoothSecurity.PairRequest(deviceInfo.DeviceAddress, myPin))
                {
                    return false;
                }
            }

            return true;
        }

    }
}
