﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using InTheHand;
using InTheHand.Net.Bluetooth;
using InTheHand.Net.Ports;
using System.IO;
using InTheHand.Net.Sockets;
using System.Threading;
using BluetoothIM.Model.Protocol.Routing;
using System.Net.Sockets;
namespace BluetoothIM.Model.Protocol.Connections
{
    public static class InputOutput // Třída pro čtení a zápis ze streamu
    {
    
        public static void Write(string address, string packet) // Metoda pro odesílání 
        {
           
            try
            {
                if (address != null &&  RoutingTable.Table.ContainsKey(address))
                {
                    byte[] bytesToSend;
                   
                    BluetoothClient client = RoutingTable.Table[address];
                    
                    bytesToSend = Encoding.Unicode.GetBytes(packet);

                    Stream str = client.GetStream();
                    str.Write(bytesToSend, 0, bytesToSend.Length);

                   
                    
          
          
                }
              
            }
            
            catch (Exception)
            {
              
                RoutingHandler.badPacketReceived(address);
                
            }
      

        }


        public static  void GetStream(BluetoothClient client) // Metoda startující vlánko pro příjem
        {
            var thread = new Thread(() => StreamThread(client));
            thread.Start();
        }
     

        private static  void StreamThread(BluetoothClient client) // Metoda která ve smyčce přijímá pakety
        {
            Stream readingStream  =  client.GetStream();
            string address = client.RemoteEndPoint.Address.ToString("C");
            string receivedStream;
            while (true)
            {
                try
                {
               
                    byte[] received = new byte[40150];

                    readingStream.Read(received, 0, received.Length);
                    receivedStream = Encoding.Unicode.GetString(received);
                    if (receivedStream[0] == '\0')
                        throw new FormatException();
                    RoutingHandler.routePacket(receivedStream, client);
                  
                   
        }
              
              
                catch(Exception)
                {
                  
                    RoutingHandler.badPacketReceived(address);
                    client.Close();
                    break; 
                }
            }
        }
    }
}
