﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using InTheHand;
using InTheHand.Net.Bluetooth;
using InTheHand.Net.Ports;
using InTheHand.Net.Sockets;
using BluetoothIM.Model.Protocol.Routing;
namespace BluetoothIM.Model.Protocol.Conversations
{
    public class Conversation // Třída reperezntující konverzaci
    {
        public Dictionary<Guid, Message> ToDeliver { get; set; }
        public List<Message> InMessageConversation { get; set; }
        public string InStringConversation { get; set; }

        public Conversation() // Konstruktor
        {
            ToDeliver = new Dictionary<Guid, Message>();
            InMessageConversation = new List<Message>();
            InStringConversation = string.Empty;
        }
        public void refreshConversation() // Obnovení konverzace
        {
             InStringConversation = string.Empty;

            foreach (Message m in InMessageConversation)
            {
              
                  
                    if (m.FromHere && !m.Delivered)
                    {
                        InStringConversation += m.Time + " " + m.Name + " says: (not delivered)\n" + m.Text + "\n";

                    }
                    else if (m.FromHere && m.Delivered)
                    {
                        InStringConversation += m.Time + " " + m.Name + " says: (delivered)\n" + m.Text + "\n";

                    }
                    else
                    {
                        InStringConversation += m.Time + " " + m.Name + " says: \n" + m.Text + "\n";
                    }
                
            }
        }
         public void refreshEveryoneConversation() // Obnovení hromadné konverzace
        {


               InStringConversation = string.Empty;

               foreach (Message m in InMessageConversation)
               {
                   string DeliveredToString = string.Empty;
                   int i = m.DeliveredTo.Count;
                   foreach (string s in m.DeliveredTo)
                   {
                       i--;
                       DeliveredToString += s;
                       if(i!=0)
                       DeliveredToString += ", ";

                   }
                 
                  
                   if (m.FromHere && (m.DeliveredTo.Count == 0))
                   {
                       InStringConversation += m.Time + " " + m.Name + " says: (no delivered)\n" + m.Text + "\n";

                   }
                   else if (m.FromHere && (m.DeliveredTo.Count > 0))
                   {
                       InStringConversation += m.Time + " " + m.Name + " says: (delivered to: " + DeliveredToString + ")\n" + m.Text + "\n";

                   }
                   else
                   {
                       InStringConversation += m.Time + " " + m.Name + " says: \n" + m.Text + "\n";
                   }
               }
        }
        public void wasDelivered(Guid deliveredID) // Označení zprávy jako doručené
        {
            if (ToDeliver.ContainsKey(deliveredID))
            {
                ToDeliver[deliveredID].deliveredNow();
                ToDeliver.Remove(deliveredID);
                refreshConversation();
            }
        }


        public void wasDelivered(string fromAddress, Guid deliveredID) // Označení hromadné zprávy jako doručené
        {
            if (ToDeliver.ContainsKey(deliveredID))
            {
                ToDeliver[deliveredID].deliveredNowTo(RoutingTable.AddressNamePairs[fromAddress]);
                refreshEveryoneConversation();
            }
        }

        
    }
}

