﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


namespace BluetoothIM.Model.Protocol.Conversations
{
    public class Message // Třída reprezentující zprávu
    {
        public string Address { get; set; }
        public string Name { get; set; }
        public string Text { get; set; }
        public string Time { get; set; }
        public bool Delivered { get; set; }
        public List<string> DeliveredTo { get; set; }
        public bool FromHere { get; set; }
        public Guid ID { get; set; }

        public Message(string address, string name, string text, Guid iD) // Konstruktor
        {
            Address = address;
            Name = name;
            Text = text;
            Time = DateTime.Now.ToString("HH:mm:ss dd-MM-yyyy");
            Delivered = false;
            FromHere = false;
            DeliveredTo = new List<string>();
            this.ID = iD;
        }
        public Message(string address, string name, string text, bool fromHere, Guid id) // Konstruktor
        {
            Address = address;
            Name = name;
            Text = text;
            Time = DateTime.Now.ToString("HH:mm:ss dd-MM-yyyy");
            Delivered = false;
            FromHere = fromHere;
            DeliveredTo = new List<string>();
            this.ID = id;
        }
        public void deliveredNow() // Označení zprávy jako doručené
        {
            Delivered = true;
        }
   
        public void deliveredNowTo(string name) // Přidání jména zařízení, kterému byla zpráva doručena
        {
            DeliveredTo.Add(name);
        }
    }
}
