﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BluetoothIM.Model.Protocol.Routing.Packets
{
    public class AcknowledgementPacket : Packet // Paket s potvrzením
    {
     
        public AcknowledgementPacket() // Konstruktor
        {
            Ttl = 64; 
        }
     
        public override string getString() // Metoda vracející serializované informace ve formě řetězce
        {
            string s = System.Convert.ToString(Ttl);
            while (s.Length != TtlLength)
                s += '\0';
            return (TypeOfPacket
                  + DestinationAddress
                  + SourceAddress
                  + PacketID.ToString()
                  + s
                  + Trailer
                  );
        }
        public override Packet getPacket(string toPacket) // Získání dat z řetězce
        {
            AcknowledgementPacket p = new AcknowledgementPacket();
            p.TypeOfPacket = toPacket[0];
            p.DestinationAddress = toPacket.Substring(p.TypeLenght, p.AddressLength);
            p.SourceAddress = toPacket.Substring(p.TypeLenght + p.AddressLength, p.AddressLength);
            p.PacketID = new Guid(toPacket.Substring(p.TypeLenght + 2 * AddressLength, GuidLenght));
            p.Ttl = Int32.Parse(toPacket.Substring(p.TypeLenght + 2 * AddressLength + GuidLenght, TtlLength).Trim(p.B));

            if (toPacket.Substring(p.TypeLenght + 2 * p.AddressLength + p.GuidLenght + TtlLength, p.Trailer.Length) == p.Trailer)
            {
                return p;
            }
            else
            {
                throw new FormatException();
            }
        }
    }
}
