﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BluetoothIM.Model.Protocol.Routing.Packets
{
    public class MessagePacket : Packet // Třída se zprávami
    {
     
      
        public int MessageCharCount { get; set; }
        public string Message { get; set; }
      
       

        public MessagePacket() // Konstruktor
        { Ttl = 64; }

        public override string getString() // Metoda vracející serializované informace ve formě řetězce
        {
            string MessageLength = MessageCharCount.ToString();
            while (MessageLength.Length != MaxLenghtOrder)
                MessageLength += B;
            

            string TTL = System.Convert.ToString(Ttl);
            while (TTL.Length != TtlLength)
                TTL += B;


            return (TypeOfPacket
                + DestinationAddress
                + SourceAddress
                + MessageLength
                + Message
                + PacketID
                + TTL
                + Trailer
                );
        }
        public override Packet getPacket(string toPacket) // Získání dat z řetězce
        {
            MessagePacket p = new MessagePacket();
            p.TypeOfPacket = toPacket[0];
            p.DestinationAddress = toPacket.Substring(p.TypeLenght, p.AddressLength);
            p.SourceAddress = toPacket.Substring(p.TypeLenght + p.AddressLength, p.AddressLength);
            p.MessageCharCount = Int32.Parse(toPacket.Substring(p.TypeLenght + 2 * p.AddressLength, p.MaxLenghtOrder).Trim(p.B));
            p.Message = toPacket.Substring(p.TypeLenght + 2 * p.AddressLength + p.MaxLenghtOrder, p.MessageCharCount);
            p.PacketID = new Guid(toPacket.Substring(p.TypeLenght + 2 * p.AddressLength + p.MaxLenghtOrder + p.MessageCharCount, p.GuidLenght));
            p.Ttl = Int32.Parse(toPacket.Substring(p.TypeLenght + 2 * p.AddressLength + p.MaxLenghtOrder + p.MessageCharCount + p.GuidLenght, TtlLength).Trim(p.B));
            if (toPacket.Substring(p.TypeLenght + 2 * p.AddressLength + p.MaxLenghtOrder + p.MessageCharCount + p.GuidLenght + TtlLength, p.Trailer.Length) == p.Trailer)
            {
                return p;
            }
            else
            {
                throw new FormatException();
            }
        }
    
    }
}
