﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BluetoothIM.Model.Protocol.Routing.Packets
{
    public abstract class Packet // Rodič paketů
    {
        public string DestinationAddress { get; set; }
        public string SourceAddress { get; set; }
        public int Ttl { get; set; }
        public Guid PacketID { get; set; }
        public char TypeOfPacket { get; set; }
        private const int maxLenghtOrder = 4;
        private const string trailer = "end";
        private const char b = '\0';
        private const int addressLength= 17;
        private const int guidLenght = 36;
        private const int typeLenght = 1;
        private const int ttlLength = 2;
        private const int dictionaryMaxLenghtOrder = 2;
        private const int nameLenght = 17;
        public int DictionaryMaxLenghtOrder
        {
            get { return dictionaryMaxLenghtOrder; }
        }


        public int MaxLenghtOrder
        {
            get { return maxLenghtOrder; }
        } 
        public int NameLenght
        {
            get { return nameLenght; }
        } 

        public string Trailer
        {
            get { return trailer; }
        } 

        public char B
        {
            get { return b; }
        } 

        public int AddressLength
        {
            get { return addressLength; }
        } 

        public int GuidLenght
        {
            get { return guidLenght; }
        } 

        public int TypeLenght
        {
            get { return typeLenght; }
        } 


        public int TtlLength
        {
            get { return ttlLength; }
        } 

        
        public Packet()
        { }
        public Packet(string destinationAddress, string sourceAddress) // Konstruktor
        {
            DestinationAddress = destinationAddress;
            SourceAddress = sourceAddress;
        }
        public abstract string getString(); // Metody k přepsání v děděných třídách
        public abstract Packet getPacket(string toPacket);
            
    }
}
