﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


namespace BluetoothIM.Model.Protocol.Routing.Packets
{
    public class UpdatePacket : Packet // Paket s informacemi o topologii
    {
      
       
        public int AddressAddressPairCount { get; set; }
        public Dictionary<string, List<string>> AddressAddressPair { get; set; }
        public int AddressNamePairCount { get; set; }
        public Dictionary<string, string> AddressNamePair { get; set; }
  
        public UpdatePacket() // Konstruktor
        {
            Ttl = 64;
            AddressAddressPair = new Dictionary<string, List<string>>();
            AddressNamePair = new Dictionary<string, string>();
        }

        public override string getString() // Metoda vracející serializované informace ve formě řetězce
        {
            string s = System.Convert.ToString(Ttl);
            while (s.Length != TtlLength)
                s += '\0';
            return (TypeOfPacket
                  + DestinationAddress
                  + SourceAddress
                  + GetUpdateInfo()
                  + s
                  + Trailer);
        }
        public override Packet getPacket(string toPacket) // Získání dat z řetězce
        {
            UpdatePacket p = new UpdatePacket();
            p.TypeOfPacket = toPacket[0];
            p.DestinationAddress = toPacket.Substring(p.TypeLenght, p.AddressLength);
            p.SourceAddress = toPacket.Substring(p.TypeLenght + p.AddressLength, p.AddressLength);
            p.AddressAddressPairCount = Int32.Parse(toPacket.Substring(p.TypeLenght + 2 * p.AddressLength, p.DictionaryMaxLenghtOrder).Trim(p.B));
            p.AddressAddressPair = p.getAddressAddressPair(toPacket);
            p.AddressNamePairCount = Int32.Parse(toPacket.Substring(p.TypeLenght + 2 * p.AddressLength + p.DictionaryMaxLenghtOrder + p.AddressAddressPairCount * 2 * p.AddressLength, p.DictionaryMaxLenghtOrder).Trim(p.B));
            p.AddressNamePair = p.getAddressNamePair(toPacket, p.TypeLenght + 2 * p.AddressLength + p.DictionaryMaxLenghtOrder + p.AddressAddressPairCount * 2 * p.AddressLength + p.DictionaryMaxLenghtOrder);
            p.Ttl = Int32.Parse(toPacket.Substring(TypeLenght + 2 * p.AddressLength + 2 * p.DictionaryMaxLenghtOrder + p.AddressAddressPairCount * 2 * p.AddressLength + p.AddressNamePairCount * (p.AddressLength + p.NameLenght), p.TtlLength).Trim(p.B));
            if ((toPacket.Substring(TypeLenght + 2 * p.AddressLength + 2 * p.DictionaryMaxLenghtOrder + p.AddressAddressPairCount * 2 * p.AddressLength + p.AddressNamePairCount * (p.AddressLength + p.NameLenght) + TtlLength, p.Trailer.Length) == p.Trailer))
            {
                return p;
            }
            else
            {
                throw new FormatException();
            }
        }
        
        private Dictionary<string, string> getAddressNamePair(string toPacket, int from) // Získání dvojic adresa - jméno
        {
            Dictionary<string, string> tmp = new Dictionary<string, string>();

            for (int i = 0; i < AddressNamePairCount; i++)
            {
                try
                {
                    tmp.Add(toPacket.Substring(from + i * (AddressLength + NameLenght), AddressLength), toPacket.Substring(from + i * (AddressLength + NameLenght) + AddressLength, NameLenght).Trim(B));
                }
                catch(ArgumentException)
                { }
            }
            return tmp;
        }

        private Dictionary<string, List<string>> getAddressAddressPair(string toPacket) // Získání topologie sítě z informací v paketu
        {
            Dictionary<string, List<string>> tmp = new Dictionary<string, List<string>>();
            for (int i = 0; i < AddressAddressPairCount; i++)
            {
                if (!tmp.ContainsKey(toPacket.Substring(TypeLenght + 2 * AddressLength + DictionaryMaxLenghtOrder + i * 2 * AddressLength, AddressLength)))
                {
                    tmp.Add(toPacket.Substring(TypeLenght + 2 * AddressLength + DictionaryMaxLenghtOrder + i * 2 * AddressLength, AddressLength), new List<string>());
                }
                tmp[toPacket.Substring(TypeLenght + 2 * AddressLength + DictionaryMaxLenghtOrder + i * 2 * AddressLength, AddressLength)]
                    .Add(toPacket.Substring(TypeLenght + 2 * AddressLength + DictionaryMaxLenghtOrder + i * 2 * AddressLength + AddressLength, AddressLength));

            }
            return tmp;
        }
        private string GetUpdateInfo() // Serializace směrovacích dat do řetězce 
        {
            if (TypeOfPacket != 'd')
            {
                AddressAddressPairCount = 0;
                foreach (string s in AddressAddressPair.Keys)
                {
                    foreach (string t in AddressAddressPair[s])
                    {
                        AddressAddressPairCount++;

                    }



                }
                AddressNamePairCount = 0;
                foreach (string s in AddressAddressPair.Keys)
                {
                    AddressNamePairCount++;

                }
            }
            string x = System.Convert.ToString(AddressAddressPairCount);
            string r = string.Empty;
            while (x.Length != DictionaryMaxLenghtOrder)
                x += B;
            r += x;
            foreach (string s in AddressAddressPair.Keys)
            {
                foreach (string t in AddressAddressPair[s])
                {
                    r += s;
                    r += t;
                }
            }
            x = System.Convert.ToString(AddressNamePairCount);
            while (x.Length != DictionaryMaxLenghtOrder)
                x += B;
            r += x;
            foreach (string u in AddressNamePair.Keys)
            {
                r += u;
                r += getName(AddressNamePair[u]);
            }
            return r;
        }
        private string getName(string name) // Unifikace délky jména
        {
            string uname = string.Empty;
            for (int i = 0; i < name.Length; i++ )
            {
                uname+=name[i];
            }
            while (uname.Length != NameLenght)
                uname += B;

            return uname;
        }


    }
}
