﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using InTheHand;
using InTheHand.Net.Bluetooth;
using InTheHand.Net.Ports;
using InTheHand.Net.Sockets;
using BluetoothIM.Model.Protocol.Routing.Packets;
using BluetoothIM.Model.Protocol.Conversations;
using BluetoothIM.Model.Protocol.Connections;
using System.IO;
namespace BluetoothIM.Model.Protocol.Routing
{
    public class RoutingHandler // Třída zajišťující směrování
    {
        public static string Status { get; set; }
        public static List<string> deleted;
        public static event setStatus statusEvent;
        public delegate void setStatus();
        static RoutingHandler() // Konstruktor
        {

        deleted = new List<string>();
          }
        public static void routePacket(string packet, BluetoothClient client) // Směrování paketů
        {
            switch (packet[0])
            {
                case 'a':
                    routeMessagePacket(packet, client);
                    break;
                case 'b':
                    routeAckPacket(packet, client);
                    
                    break;
                case 'c':
                    routeUpdatePacket(packet, client);
                    
                    break;
                case 'd':
                    routeUpdateDeletePacket(packet, client);
                   
                    break;
                case 'e':
                    routeMessagePacket(packet, client);
                  
                    break;
                case 'f':
                    routeAckPacket(packet, client);
                   
                    break;
                default:
                       badPacketReceived(client.RemoteEndPoint.Address.ToString("C"));
                    break;
            }

        }
      
        private static void routeAckPacket(string packet, BluetoothClient client) // Zpracování potvrzení
        {
            AcknowledgementPacket ack = new AcknowledgementPacket();
            try
            {
                ack = (AcknowledgementPacket)ack.getPacket(packet);
            }
            catch (FormatException)
            {  
                badPacketReceived(client.RemoteEndPoint.Address.ToString("C")); 

            }
            if (ack.DestinationAddress == BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C")) 
            {
                if (ack.TypeOfPacket == 'f')
                {
                    Room.delivered("Everyone", ack.SourceAddress, ack.PacketID);
                }
                else
                {
                    Room.delivered(ack.SourceAddress, ack.PacketID);
                }
            }
            else
                reSend(ack);
        }
        private static void routeMessagePacket(string packet, BluetoothClient client) // Zpracování zprávy
        {
            MessagePacket msg = new MessagePacket();
            try
            {
                msg = (MessagePacket)msg.getPacket(packet);
            }
            catch (FormatException)
            {

                  badPacketReceived(client.RemoteEndPoint.Address.ToString("C"));
            }

            if (msg.DestinationAddress == BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C")) 
            {
                if (msg.TypeOfPacket == 'e')
                    Room.newMessageReceived("Everyone", RoutingTable.AddressNamePairs[msg.SourceAddress], msg.Message, msg.PacketID);
                else
                    Room.newMessageReceived(msg.SourceAddress, RoutingTable.AddressNamePairs[msg.SourceAddress], msg.Message, msg.PacketID);
                   
                sendAck(msg);

            }
            else
                reSend(msg);

        }
        private static void routeUpdatePacket(string packet, BluetoothClient client) // Zpracování směrovacích informací
        {
            UpdatePacket upd = new UpdatePacket();
            try
            {
                upd = (UpdatePacket)upd.getPacket(packet);
            }
            catch (FormatException)
            {

                   badPacketReceived(client.RemoteEndPoint.Address.ToString("C"));
            }
            if (upd.DestinationAddress == BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C")) 
            {
                foreach (string s in upd.AddressAddressPair.Keys)
                {
                    foreach (string t in upd.AddressAddressPair[s])
                    {
                        if (RoutingTable.AddressListAddressPairs.ContainsKey(s) && !RoutingTable.AddressListAddressPairs[s].Contains(t))
                            RoutingTable.AddressListAddressPairs[s].Add(t);
                        if (!RoutingTable.AddressListAddressPairs.ContainsKey(s))
                        {
                            RoutingTable.AddressListAddressPairs.Add(s, new List<string>());
                            if (!RoutingTable.AddressListAddressPairs[s].Contains(t))
                            {

                                RoutingTable.AddressListAddressPairs[s].Add(t);
                            }
                        }
                    }

                }
                List<string> toSendBack = new List<string>();
                foreach (string t in upd.AddressNamePair.Keys)
                {
                    if (!RoutingTable.AddressNamePairs.ContainsKey(t))
                    {
                        RoutingTable.AddressNamePairs.Add(t, upd.AddressNamePair[t]);
                        toSendBack.Add(t);
                        if (RoutingHandler.deleted.Contains(client.RemoteEndPoint.Address.ToString("C")))
                            RoutingHandler.deleted.Remove(client.RemoteEndPoint.Address.ToString("C"));

                    }
                }
                foreach (string t in upd.AddressNamePair.Keys)
                {
                    if (!RoutingTable.NameAddressPairs.ContainsKey(upd.AddressNamePair[t]))
                    {
                        RoutingTable.NameAddressPairs.Add(upd.AddressNamePair[t], t);

                    }
                }
                foreach (string t in upd.AddressNamePair.Keys)
                {
                    if (!RoutingTable.MemberNames.Contains(upd.AddressNamePair[t]))
                    {
                        RoutingTable.MemberNames.Add(upd.AddressNamePair[t]);

                    }
                }
                foreach (string t in upd.AddressNamePair.Keys)
                {
                    if(!Room.Conversations.ContainsKey(t))
                    Room.Conversations.Add(t, new Conversation());

                }
               
                
                RoutingAlgorithm.run();
                Room.getRoomMembers();
                Room.connected();
                foreach(string s in toSendBack)
                SendUpdate(s);
           
            }
            else
                reSend(upd);
        }
        private static void routeUpdateDeletePacket(string packet, BluetoothClient client) // Zpracování informace o zaniklém spojení
        {
            UpdatePacket upd = new UpdatePacket();
            try
            {
                upd = (UpdatePacket)upd.getPacket(packet);
            }
            catch (FormatException)
            {

                badPacketReceived(client.RemoteEndPoint.Address.ToString("C"));
            }
            if (upd.DestinationAddress == BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C")) 
            {

                removeLink(upd.AddressAddressPair.Keys.ElementAt(0), upd.AddressAddressPair.Keys.ElementAt(1));
                RoutingAlgorithm.run();
                Room.connected();
           
            }
            else
                reSend(upd);

        }

        public static void badPacketReceived(string address) // Zpracování přijetí špatného paketu
        {
            if(!deleted.Contains(address))
            { 
            deleted.Add(address);
            
            foreach (string s in RoutingTable.Table.Keys)
            {
              
                    if (s != address)
                        SendDeleteUpdate(BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C"), address, s);
                
              
            }
            if(RoutingTable.AddressNamePairs.ContainsKey(address))
            Status = RoutingTable.AddressNamePairs[address] + "\nhas been disconnected";
                  if(statusEvent!=null)
                  {
                      statusEvent();
                  }
            
            removeClient(address);
        
         }

        }
        private static void SendDeleteUpdate(string addressOne, string addressTwo, string address) // Odeslání informace o zrušeném spojení
        {
            Dictionary<string, List<string>> d = new Dictionary<string, List<string>>();
            d.Add(addressOne, new List<string>());
            d[addressOne].Add(addressTwo);
            d.Add(addressTwo, new List<string>());
            d[addressTwo].Add(addressOne);
            UpdatePacket p = new UpdatePacket();
            p.TypeOfPacket = 'd';
            p.AddressAddressPair = d;
            p.AddressNamePair = new Dictionary<string, string>();
            p.DestinationAddress = address;
            p.SourceAddress = BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C");
            p.AddressNamePairCount = 0;
            p.AddressAddressPairCount = 2;
            p.Ttl = 64;
            sendToDestination(p.DestinationAddress, p.getString());
        }

        private static void removeClient(string address) // Odstranění připojeného zařízení z topologie
        {

            RoutingTable.removeAddressListAddressPair(address, BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C"));
            RoutingTable.removeAddressDirectlyConnectedPair(address);
            RoutingAlgorithm.run();
            List<string> nameCopy = new List<string>();
		    foreach(string s in RoutingTable.AddressNamePairs.Keys)
            {
                nameCopy.Add(s);
            }
            foreach(string s in nameCopy)
            {
                if (!RoutingTable.Table.Keys.Contains(s) && !(BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C")==s))
                {
                   
                    RoutingTable.AddressListAddressPairs.Remove(s);
                    RoutingTable.removeMemberName(RoutingTable.AddressNamePairs[s]);
                    RoutingTable.removeNameAddressPair(RoutingTable.AddressNamePairs[s]);
                    RoutingTable.removeAddressNamePair(s);
                    Room.Conversations.Remove(s);
                }
              
            }
         
                Room.getRoomMembers();
                Room.failed();
            

        }

        public static void SendUpdate(string address)  // Zaslání informací o topologii
        {
            UpdatePacket p = new UpdatePacket();
            p.TypeOfPacket = 'c';
            p.AddressAddressPair = RoutingTable.AddressListAddressPairs;
            p.AddressNamePair = RoutingTable.AddressNamePairs;
            p.SourceAddress = BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C");
            p.DestinationAddress = address;
            p.AddressNamePairCount = RoutingTable.AddressNamePairs.Count;
            p.AddressAddressPairCount = RoutingTable.getAddressPairCount();
            p.Ttl = 64;

            sendToDestination(p.DestinationAddress, p.getString());
        }

        private static void removeLink(string addressOne, string addressTwo) // Odstranění spojení z topologie
        {
            RoutingTable.removeAddressListAddressPair(addressOne, addressTwo);
            RoutingAlgorithm.run();
            List<string> nameCopy = new List<string>();
            foreach (string s in RoutingTable.AddressNamePairs.Keys)
            {
                nameCopy.Add(s);
            }
            foreach (string s in nameCopy)
            {
                if (!RoutingTable.Table.Keys.Contains(s) && !(BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C")==s))
                {
                    Room.Status = RoutingTable.AddressNamePairs[s] + "\nhas left room";
                    Room.status();
                    RoutingTable.AddressListAddressPairs.Remove(s);
                    RoutingTable.removeMemberName(RoutingTable.AddressNamePairs[s]);
                    RoutingTable.removeNameAddressPair(RoutingTable.AddressNamePairs[s]);
                    RoutingTable.removeAddressNamePair(s);
                    Room.Conversations.Remove(s);
                }

            }
          
            Room.getRoomMembers();
            Room.failed();

            
            


          
        }
        public static void sendMessageTo(string toAddress, string text, Guid guid) // Poslání zprávy
        {
            MessagePacket p = new MessagePacket();
         
                if (toAddress == "Everyone")
                {
                    foreach (string s in RoutingTable.Table.Keys)
                    {
                        p.TypeOfPacket = 'e';
                        p.Message = text;
                        p.DestinationAddress = s;
                        p.SourceAddress = BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C");
                        p.MessageCharCount = text.Length;
                        p.Ttl = 64;
                        p.PacketID = guid;
                        sendToDestination(p.DestinationAddress, p.getString());
                    }
                }
                else
                {
                    p.TypeOfPacket = 'a';
                    p.Message = text;
                    p.DestinationAddress = toAddress;
                    p.SourceAddress = BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C");
                    p.MessageCharCount = text.Length;
                    p.Ttl = 64;
                    p.PacketID = guid;
                    sendToDestination(p.DestinationAddress, p.getString());
                }
           
            
        }
        private static void sendAck(Packet packet) // Odeslání potvrzení
        {
                AcknowledgementPacket ack = new AcknowledgementPacket();
                if (packet.TypeOfPacket == 'e')
                    ack.TypeOfPacket = 'f';
                else
                    ack.TypeOfPacket = 'b';
                ack.SourceAddress = BluetoothRadio.PrimaryRadio.LocalAddress.ToString("C");
                ack.DestinationAddress = packet.SourceAddress;
                ack.PacketID = packet.PacketID;
                ack.Ttl = 64;
                sendToDestination(ack.DestinationAddress, ack.getString());
        }

        private static void reSend(Packet packet) // Přeposlání
        {
            packet.Ttl -= 1;
            sendToDestination(packet.DestinationAddress, packet.getString()); 

        }
        private static async void sendToDestination(string address, string packet) // Předání zprávy k odeslání nižší vrstvě
        {         
            await Task.Run(() =>InputOutput.Write(address, packet)); 
        }
    }
}
