﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using InTheHand;
using InTheHand.Net.Bluetooth;
using InTheHand.Net.Ports;
using InTheHand.Net.Sockets;
using BluetoothIM.Model.Protocol.Connections;
using BluetoothIM.Model.Protocol.Conversations;
using BluetoothIM.Model.Protocol.Routing;
using System.IO;
namespace BluetoothIM.ViewModel
{
    public class IMViewModelLogic // Třída sloužící k propojení datacontextu s protokolu
    {
       
        private IMViewModel vm;
        private Thread scanningThread;
        private Listening listener;
      
        public Listening Listener
        {
            get { return listener; }
            set { listener = value; }
        }
        public Thread ScanningThread
        {
            get { return scanningThread; }
            set { scanningThread = value; }
        }

        public IMViewModel Vm
        {
            get { return vm; }
            set { vm = value; }
        }
        public IMViewModelLogic(IMViewModel VM) // Konstruktor
        {
            Vm = VM;
            init();
        }
        public void init() // Metoda kde je uskutečňováno přihlašování k protokolem generovaným událostem
        {
         
                Room.message += (string address) =>
                {
                    Vm.InputText = Room.Conversations[address].InStringConversation;
                    if (address == "Everyone")
                        Vm.Conversation = address;
                    else
                        Vm.Conversation = RoutingTable.AddressNamePairs[address];

                };
                Room.connectionDone += () =>
                {
                    List<string> s = new List<string>();

                    foreach (string t in Room.Members)
                        s.Add(t);

                    Vm.RoomMembers = s;
                };
                Room.connectionFailed += () =>
                {
                    List<string> s = new List<string>();

                    foreach (string t in Room.Members)
                        s.Add(t);

                    Vm.RoomMembers = s;
                };
                Scanning.scanDone += () =>
                {
                    List<string> s = new List<string>();

                    foreach (string t in Scanning.InRangeList)
                        s.Add(t);
                    Vm.InRangeCollection = s;
                };
                RoutingHandler.statusEvent += () =>
                {
                    vm.Connection = RoutingHandler.Status;
                    System.Timers.Timer t;
                    t = new System.Timers.Timer();
                    t.Interval = 4000;
                    t.Elapsed += new System.Timers.ElapsedEventHandler(resetStatus);
                    t.Start();
                };
                Room.statusEvent += () =>
                {
                    Vm.Connection = Room.Status;
                    System.Timers.Timer t;
                    t = new System.Timers.Timer();
                    t.Interval = 4000;
                    t.Elapsed += new System.Timers.ElapsedEventHandler(resetStatus);
                    t.Start();
                };

               
                BluetoothRadio.PrimaryRadio.Mode = RadioMode.Discoverable;
                listener = new Listening();
                listener.setupListener();

          
            
        }
        public static void SendMessage(string name, string message) // Poslání zprávy
        {
            Room.sendMessageTo(name, message);
        }

        public static async void Connect(int ToConnect) // Připojení
        {
            Connecting c = new Connecting(Scanning.Devices.ElementAt(ToConnect));
            await Task.Run(() =>  c.connectToDevice());
        }
        private void resetStatus(object source, EventArgs e) // Vymazání statusu
        {
            Vm.Connection = "";
        }
    }
}
